## cmark 0.30.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(cmark VERSION 0.30.2)

include("FindAsan.cmake")
include(GNUInstallDirs)

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "Do not build in-source.\nPlease remove CMakeCache.txt and the CMakeFiles/ directory.\nThen: mkdir build ; cd build ; cmake .. ; make")
endif()

option(CMARK_TESTS "Build cmark tests and enable testing" ON)
option(CMARK_STATIC "Build static libcmark library" ON)
option(CMARK_SHARED "Build shared libcmark library" ON)
option(CMARK_LIB_FUZZER "Build libFuzzer fuzzing harness" OFF)

if(NOT MSVC)
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_C_STANDARD_REQUIRED YES)
  set(CMAKE_C_EXTENSIONS NO)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# The Linux modules distributed with CMake add "-rdynamic" to the build flags
# which is incompatible with static linking under certain configurations.
# Unsetting CMAKE_SHARED_LIBRARY_LINK_C_FLAGS ensures this does not happen.
if(CMARK_STATIC AND "${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
  SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
endif()

# Check integrity of node structure when compiled as debug
add_compile_options($<$<CONFIG:Debug>:-DCMARK_DEBUG_NODES>)

# In order to maintain compatibility with older platforms which may not have a
# recent version of CMake (i.e. are running CMake <3.3), we cannot simply use
# the `add_compile_options` with a generator expression.  This uses the
# `target_compile_options` with `PRIVATE` to add the flags only to the targets
# so that CMark may be used in projects with non-C languages.
function(cmark_add_compile_options target)
  if(MSVC)
    target_compile_options(${target} PRIVATE /W4 /wd4706)
    if(MSVC_VERSION LESS 1800)
      target_compile_options(${target} PRIVATE /TP)
    endif()
    target_compile_definitions(${target} PRIVATE _CRT_SECURE_NO_WARNINGS)
  else()
    target_compile_options(${target} PRIVATE -Wall -Wextra -pedantic)
  endif()
  if(CMAKE_BUILD_TYPE MATCHES profile)
    target_compile_options(${target} PRIVATE -pg)
  endif()
  if(CMAKE_BUILD_TYPE MATCHES ubsan)
    target_compile_options(${target} PRIVATE -fsanitize=undefined)
  endif()
  if(CMARK_LIB_FUZZER)
    target_compile_options(${target} PRIVATE -fsanitize-coverage=trace-pc-guard)
  endif()
endfunction()

add_subdirectory(src)
if(CMARK_TESTS AND (CMARK_SHARED OR CMARK_STATIC))
  add_subdirectory(api_test)
endif()
# TODO(compnerd) should this be enabled for MinGW, which sets CMAKE_SYSTEM_NAME
# to Windows, but defines `MINGW`.
if(NOT CMAKE_SYSTEM_NAME STREQUAL Windows)
  add_subdirectory(man)
endif()
if(CMARK_TESTS)
  enable_testing()
  add_subdirectory(test testdir)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
  "Choose the type of build, options are: Debug Profile Release Asan Ubsan." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

=== api_test/CMakeLists.txt ===
add_executable(api_test
  cplusplus.cpp
  harness.c
  harness.h
  main.c
)
cmark_add_compile_options(api_test)
if(CMARK_SHARED)
  target_link_libraries(api_test cmark)
else()
  target_link_libraries(api_test cmark_static)
endif()

=== src/CMakeLists.txt ===
if(${CMAKE_VERSION} VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
endif()

set(LIBRARY "cmark")
set(STATICLIBRARY "cmark_static")
set(HEADERS
  cmark.h
  parser.h
  buffer.h
  node.h
  iterator.h
  chunk.h
  references.h
  utf8.h
  scanners.h
  inlines.h
  houdini.h
  cmark_ctype.h
  render.h
  )
set(LIBRARY_SOURCES
  cmark.c
  node.c
  iterator.c
  blocks.c
  inlines.c
  scanners.c
  scanners.re
  utf8.c
  buffer.c
  references.c
  render.c
  man.c
  xml.c
  html.c
  commonmark.c
  latex.c
  houdini_href_e.c
  houdini_html_e.c
  houdini_html_u.c
  cmark_ctype.c
  ${HEADERS}
  )

set(PROGRAM "cmark_exe")
set(PROGRAM_SOURCES main.c)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmark_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmark_version.h)

include(GNUInstallDirs)
include (GenerateExportHeader)

add_executable(${PROGRAM} ${PROGRAM_SOURCES})
cmark_add_compile_options(${PROGRAM})
set_target_properties(${PROGRAM} PROPERTIES
  OUTPUT_NAME "cmark")

if (CMARK_STATIC)
  target_link_libraries(${PROGRAM} ${STATICLIBRARY})
  # Disable the PUBLIC declarations when compiling the executable:
  set_target_properties(${PROGRAM} PROPERTIES
    COMPILE_FLAGS -DCMARK_STATIC_DEFINE)
elseif (CMARK_SHARED)
  target_link_libraries(${PROGRAM} ${LIBRARY})
endif()

# -fvisibility=hidden
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

if (CMARK_SHARED)
  add_library(${LIBRARY} SHARED ${LIBRARY_SOURCES})
  cmark_add_compile_options(${LIBRARY})
  set_target_properties(${LIBRARY} PROPERTIES
    MACOSX_RPATH TRUE
    OUTPUT_NAME "cmark"
    # Avoid name clash between PROGRAM and LIBRARY pdb files.
    PDB_NAME cmark_dll
    # Include minor version and patch level in soname for now.
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
    VERSION ${PROJECT_VERSION})
  target_include_directories(${LIBRARY} INTERFACE
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  add_library(cmark::cmark ALIAS ${LIBRARY})

  generate_export_header(${LIBRARY}
    BASE_NAME ${PROJECT_NAME})

  list(APPEND CMARK_INSTALL ${LIBRARY})
endif()

if (CMARK_STATIC)
  add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})
  cmark_add_compile_options(${STATICLIBRARY})
  set_target_properties(${STATICLIBRARY} PROPERTIES
    COMPILE_FLAGS -DCMARK_STATIC_DEFINE
    POSITION_INDEPENDENT_CODE ON
    VERSION ${PROJECT_VERSION})
  if(MSVC)
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME cmark_static)
  else()
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME cmark)
  endif()
  target_include_directories(${STATICLIBRARY} INTERFACE
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  add_library(cmark::cmark_static ALIAS ${STATICLIBRARY})

  if (NOT CMARK_SHARED)
    generate_export_header(${STATICLIBRARY}
      BASE_NAME ${PROJECT_NAME})
  endif()

  list(APPEND CMARK_INSTALL ${STATICLIBRARY})
endif()

if (MSVC)
  set_property(TARGET ${PROGRAM}
    APPEND PROPERTY LINK_FLAGS /INCREMENTAL:NO)
endif(MSVC)

if(NOT MSVC OR CMAKE_HOST_SYSTEM_NAME STREQUAL Windows)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
  include(InstallRequiredSystemLibraries)
endif()

install(TARGETS ${PROGRAM} ${CMARK_INSTALL}
  EXPORT cmark-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

if(CMARK_SHARED OR CMARK_STATIC)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libcmark.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libcmark.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcmark.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

  install(FILES
    cmark.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark_version.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    )

  # Include module for fuctions
  # - 'write_basic_package_version_file'
  # - 'configure_package_config_file'
  include(CMakePackageConfigHelpers)
  # generate cmark-config.cmake and cmark-config-version.cmake files
  configure_package_config_file(
    "cmarkConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/generated/cmark-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/cmark")
  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/generated/cmark-config-version.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion)
  # install config and version file
  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/generated/cmark-config.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/generated/cmark-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/cmark"
  )
  # install targets file
  install(
    EXPORT "cmark-targets"
    NAMESPACE "cmark::"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/cmark"
  )

endif()

# Feature tests
include(CheckIncludeFile)
include(CheckCSourceCompiles)
CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
CHECK_C_SOURCE_COMPILES(
  "int main() { __builtin_expect(0,0); return 0; }"
  HAVE___BUILTIN_EXPECT)
CHECK_C_SOURCE_COMPILES("
  int f(void) __attribute__ (());
  int main() { return 0; }
" HAVE___ATTRIBUTE__)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

if(CMARK_LIB_FUZZER)
  add_executable(cmark-fuzz ../test/cmark-fuzz.c ${LIBRARY_SOURCES})
  cmark_add_compile_options(cmark-fuzz)
  target_link_libraries(cmark-fuzz "${CMAKE_LIB_FUZZER_PATH}")

  # cmark is written in C but the libFuzzer runtime is written in C++ which
  # needs to link against the C++ runtime.
  set_target_properties(cmark-fuzz PROPERTIES
    LINKER_LANGUAGE CXX)
endif()

=== test/CMakeLists.txt ===
# To get verbose output: cmake --build build --target "test" -- ARGS='-V'

# By default, we run the spec tests only if python3 is available.
# To require the spec tests, compile with -DSPEC_TESTS=1

if (SPEC_TESTS)
  find_package(PythonInterp 3 REQUIRED)
else(SPEC_TESTS)
  find_package(PythonInterp 3)
endif(SPEC_TESTS)

if (CMARK_SHARED OR CMARK_STATIC)
  add_test(NAME api_test COMMAND api_test)
endif()

if (WIN32)
  file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR}/src WIN_DLL_DIR)
  set(NEWPATH "${WIN_DLL_DIR};$ENV{PATH}")
  string(REPLACE ";" "\\;" NEWPATH "${NEWPATH}")
  set_tests_properties(api_test PROPERTIES ENVIRONMENT "PATH=${NEWPATH}")
  set(ROUNDTRIP "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip.bat")
else(WIN32)
  set(ROUNDTRIP "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip.sh")
endif(WIN32)

IF (PYTHONINTERP_FOUND)

  add_test(html_normalization
    ${PYTHON_EXECUTABLE} "-m" "doctest"
    "${CMAKE_CURRENT_SOURCE_DIR}/normalize.py"
    )

  if (CMARK_SHARED)
    add_test(spectest_library
      ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec"
      "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt" "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(pathological_tests_library
      ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/pathological_tests.py"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(roundtriptest_library
      ${PYTHON_EXECUTABLE}
      "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
      "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(entity_library
      ${PYTHON_EXECUTABLE}
      "${CMAKE_CURRENT_SOURCE_DIR}/entity_tests.py"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )
  endif()

  add_test(spectest_executable
    ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt" "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark"
    )

  add_test(smartpuncttest_executable
    ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/smart_punct.txt" "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark --smart"
    )

  add_test(regressiontest_executable
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec"
    "${CMAKE_CURRENT_SOURCE_DIR}/regression.txt" "--program"
    "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark"
    )

ELSE(PYTHONINTERP_FOUND)

  message("\n*** A python 3 interpreter is required to run the spec tests.\n")
  add_test(skipping_spectests
    echo "Skipping spec tests, because no python 3 interpreter is available.")

ENDIF(PYTHONINTERP_FOUND)

=== debian/changelog ===
cmark (0.30.2-5) unstable; urgency=medium

  * Revert plain wrong change to shlibs hint file;
    closes: bug#1004453, thanks to Peter Green

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 28 Jan 2022 10:06:31 +0100

cmark (0.30.2-4) unstable; urgency=medium

  * fix tighten generated shlibs hint file,
    to reflect that upstream does not yet provide a stable ABI;
    add related lintian override;
    closes: bug#1003970, thanks to Gregor Herrmann
  * update copyright info:
    + use Reference field for main wildcard Files section;
      tighten lintian overrides
    + update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 18 Jan 2022 19:55:18 +0100

cmark (0.30.2-3) unstable; urgency=medium

  * simple re-release, uploaded source-only to be acceptable for testing

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 27 Oct 2021 04:16:19 +0200

cmark (0.30.2-2) unstable; urgency=medium

  * fix build binary package libcmark0.30.2 (not libcmark0.30.1),
    and have it break recent broken release of libcmark0.30.1;
    closes: bug#996887:, thanks to Sebastian Ramacher

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Oct 2021 16:57:49 +0200

cmark (0.30.2-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * simplify source helper script copyright-check
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 18 Oct 2021 02:19:52 +0200

cmark (0.30.1-2) unstable; urgency=medium

  * release to unstable

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 19 Aug 2021 22:53:19 +0200

cmark (0.30.1-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.6.0
  * install to new binary package libcmark0.30.1

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Aug 2021 21:52:53 +0200

cmark (0.30.0-1~exp1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * use debhelper compatibility level 13 (not 12)
  * declare debhelper buildsystem explicitly
  * copyright info:
    + update coverage
    + fix a file reference
  * drop all patches: applied upstream
  * new binary package libcmark0.30 (replacing libcmark0.29)
    to match upstream SONAME bump

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Jun 2021 12:16:45 +0200

cmark (0.29.0-4) unstable; urgency=medium

  * fix export DH_OPTIONS
  * add patch to extend timeput in pathological test

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Jun 2020 08:31:10 +0200

cmark (0.29.0-3) unstable; urgency=medium

  * update Homepage, Source, and Upstream-Contact URLs;
    closes: 962576, thanks to Chris Lamb
  * copyright:
    + fix distinguish between License-Grant and License-Reference
      (and non-license disclaimers now omitted)
    + sort sections, Files above License
    + use semantic newlines, and newline-separate files
    + add coverage of recent packaging work
  * Long descriptions:
    + use semantic newlines, and strip duplicate text
    + add comparison to other markdown parsers, and define markdown
      (inspired by Haskell cmark wrapper description
      and Wikipedia article on Markdown)
  * include helper script copyright-check with source
  * override lintian regarding license in License-Reference field;
    see bug#786450
  * simplify rules: stop pass INSTALL_PREFIX,
    seemingly obsoleted by multiarch patch 1001

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 10 Jun 2020 11:10:44 +0200

=== debian/control ===
Source: cmark
Section: text
Priority: optional
Maintainer: Jonas Smedegaard <dr@jones.dk>
Homepage: https://github.com/commonmark/cmark
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/cmark.git
Vcs-Browser: https://salsa.debian.org/debian/cmark
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 python3,

Package: cmark
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: CommonMark parsing and rendering program
 cmark is the C reference implementation of CommonMark,
 a rationalized version of Markdown syntax with a spec.
 .
 cmark parses almost as fast as sundown and hoedown
 (but safer and less buggy),
 about 3 times faster than discount,
 and about 100 times faster than kramdown and pandoc.
 Memory consumption is on par with sundown
 and about 10 times less than pandoc.
 .
 cmark outputs HTML, groff man, LaTeX, CommonMark,
 and a custom XML format.
 .
 Markdown is a lightweight markup language
 with plain-text-formatting syntax.
 .
 This package provides a command-line program (cmark)
 for parsing and rendering CommonMark documents.

Package: libcmark0.30.2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libcmark0.30.1 (>= 0.30.2),
Description: CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark,
 a rationalized version of Markdown syntax with a spec.
 .
 cmark parses almost as fast as sundown and hoedown
 (but safer and less buggy),
 about 3 times faster than discount,
 and about 100 times faster than kramdown and pandoc.
 Memory consumption is on par with sundown
 and about 10 times less than pandoc.
 .
 cmark outputs HTML, groff man, LaTeX, CommonMark,
 and a custom XML format.
 .
 Markdown is a lightweight markup language
 with plain-text-formatting syntax.
 .
 This package contains the shared libraries.

Package: libcmark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libcmark0.30.2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for CommonMark parsing and rendering library
 cmark is the C reference implementation of CommonMark,
 a rationalized version of Markdown syntax with a spec.
 .
 cmark parses almost as fast as sundown and hoedown
 (but safer and less buggy),
 about 3 times faster than discount,
 and about 100 times faster than kramdown and pandoc.
 Memory consumption is on par with sundown
 and about 10 times less than pandoc.
 .
 cmark outputs HTML, groff man, LaTeX, CommonMark,
 and a custom XML format.
 .
 Markdown is a lightweight markup language
 with plain-text-formatting syntax.
 .
 This package contains the header and development files.

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://github.com/commonmark/cmark/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## cmark 0.30.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(cmark VERSION 0.30.2)
+project(cmark VERSION 0.30.3)
 
 include("FindAsan.cmake")
 include(GNUInstallDirs)
@@ -44,7 +44,9 @@
     endif()
     target_compile_definitions(${target} PRIVATE _CRT_SECURE_NO_WARNINGS)
   else()
-    target_compile_options(${target} PRIVATE -Wall -Wextra -pedantic)
+    target_compile_options(${target} PRIVATE
+            -Wall -Wextra -pedantic
+            $<$<COMPILE_LANGUAGE:C>:-Wstrict-prototypes>)
   endif()
   if(CMAKE_BUILD_TYPE MATCHES profile)
     target_compile_options(${target} PRIVATE -pg)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -151,7 +151,7 @@
     DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
     )
 
-  # Include module for fuctions
+  # Include module for functions
   # - 'write_basic_package_version_file'
   # - 'configure_package_config_file'
   include(CMakePackageConfigHelpers)

=== debian/changelog ===
cmark (0.30.3-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update copyright info: update coverage
  * rename library package

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jan 2023 23:30:46 +0100

cmark (0.30.2-6) unstable; urgency=medium

  * update git-buildpackage config:
    + use DEP-14 git branches
    + enable automatic DEP-14 branch name handling
    + add usage config
  * declare compliance with Debian Policy 4.6.2
  * set Multi-Arch: foreign;
    closes: bug#1027147, thanks to Andrea Pappacoda

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 31 Dec 2022 11:59:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Jonas Smedegaard <dr@jones.dk>
 Homepage: https://github.com/commonmark/cmark
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian/cmark.git
 Vcs-Browser: https://salsa.debian.org/debian/cmark
 Rules-Requires-Root: no
@@ -14,6 +14,7 @@
 
 Package: cmark
 Architecture: any
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -37,15 +38,13 @@
  This package provides a command-line program (cmark)
  for parsing and rendering CommonMark documents.
 
-Package: libcmark0.30.2
+Package: libcmark0.30.3
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Breaks:
- libcmark0.30.1 (>= 0.30.2),
 Description: CommonMark parsing and rendering library
  cmark is the C reference implementation of CommonMark,
  a rationalized version of Markdown syntax with a spec.
@@ -70,7 +69,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libcmark0.30.2 (= ${binary:Version}),
+ libcmark0.30.3 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: development files for CommonMark parsing and rendering library

=== debian/rules ===
#!/usr/bin/make -f

export CTEST_TEST_TIMEOUT=1800

%:
	dh $@ --buildsystem=cmake

## cmark 0.31.2%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: cmark
 Section: text
-Priority: optional
 Maintainer: Jonas Smedegaard <dr@jones.dk>
 Homepage: https://github.com/commonmark/cmark
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/debian/cmark.git
 Vcs-Browser: https://salsa.debian.org/debian/cmark
-Rules-Requires-Root: no
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ dh-cmake-compat (= 1),
+ dh-sequence-cmake,
  python3,
 
 Package: cmark
@@ -38,7 +38,7 @@
  This package provides a command-line program (cmark)
  for parsing and rendering CommonMark documents.
 
-Package: libcmark0.30.3
+Package: libcmark0.31.2
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -69,7 +69,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libcmark0.30.3 (= ${binary:Version}),
+ libcmark0.31.0 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: development files for CommonMark parsing and rendering library

## cmark 0.31.2+ds

=== test/CMakeLists.txt ===
# To get verbose output: cmake --build build --target "test" -- ARGS='-V'

# By default, we run the spec tests only if python3 is available.
# To require the spec tests, compile with -DSPEC_TESTS=1

if(SPEC_TESTS)
  set(PYTHON_REQUIRED REQUIRED)
else()
  set(PYTHON_REQUIRED)
endif()

find_package(Python3 ${PYTHON_REQUIRED} COMPONENTS Interpreter)

IF (Python3_Interpreter_FOUND)

  add_test(NAME html_normalization
           COMMAND "$<TARGET_FILE:Python3::Interpreter>" -m doctest "${CMAKE_CURRENT_SOURCE_DIR}/normalize.py")

  if(BUILD_SHARED_LIBS)
    add_test(NAME spectest_library
             COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py"
                                                           --no-normalize
                                                           --spec "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt"
                                                           --library-dir "$<TARGET_FILE_DIR:cmark>")

    add_test(NAME pathological_tests_library
             COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/pathological_tests.py"
                                                           --library-dir "$<TARGET_FILE_DIR:cmark>")

    add_test(NAME roundtriptest_library
             COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
                                                           --spec "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt"
                                                           --library-dir "$<TARGET_FILE_DIR:cmark>")

    add_test(NAME entity_library
             COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/entity_tests.py"
                                                           --library-dir "$<TARGET_FILE_DIR:cmark>")
  endif()

  add_test(NAME spectest_executable
           COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py"
                                                         --no-normalize
                                                         --spec "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt"
                                                         --program "$<TARGET_FILE:cmark_exe>")

  add_test(NAME smartpuncttest_executable
           COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py"
                                                         --no-normalize
                                                         --spec "${CMAKE_CURRENT_SOURCE_DIR}/smart_punct.txt"
                                                         --program "$<TARGET_FILE:cmark_exe> --smart")

  add_test(NAME regressiontest_executable
           COMMAND "$<TARGET_FILE:Python3::Interpreter>" "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py"
                                                         --no-normalize
                                                         --spec "${CMAKE_CURRENT_SOURCE_DIR}/regression.txt"
                                                         --program "$<TARGET_FILE:cmark_exe>")

ELSE(Python3_Interpreter_FOUND)

  message(WARNING "A Python 3 Interpreter is required to run the spec tests")

ENDIF(Python3_Interpreter_FOUND)

=== debian/changelog ===
cmark (0.31.2+ds-1) experimental; urgency=medium

  * bump library package version, to reflect SONAME change
  * update copyright info:
    + update coverage
    + avoid any .git* files when repackaging upstream source
    + license patches same as main upstream license
  * enable new CFLAG BUILD_SHARED_LIBS
  * declare compliance with Debian Policy 4.7.3
  * add metadata about upstream project
  * build-depend on dh-cmake-compat dh-sequence-cmake
  * update git-buildpackage config:
    + filter out debian subdir
    + stop superfluously filter out .git* files
  * update watch file:
    + use file format version 5
    + mangle upstream and Debian versions
    + stop mangle filename
    + use repack suffix +ds

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 14 Feb 2026 17:56:36 +0100

cmark (0.31.1-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * bump library package version, to reflect SONAME change
  * update copyright info: update coverage
  * enable new CFLAG BUILD_SHARED_LIBS
  * add patches cherry-picked upstream:
    + fix inline source positions
    + update to Unicode 16.0
  * declare compliance with Debian Policy 4.7.2
  * add metadata about upstream project
  * build-depend on dh-sequence-cmake

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 23 Mar 2025 21:23:12 +0100

=== debian/rules ===
#!/usr/bin/make -f

export CTEST_TEST_TIMEOUT=1800

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DBUILD_SHARED_LIBS=YES

=== debian/watch ===
version: 5
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

Template: Github
Owner: commonmark
Project: cmark
Uversion-Mangle: auto
Dversion-Mangle: auto
Repacksuffix: +ds
